//****************************************************************************
// @Module        Parallel Ports
// @Filename      IO.C
// @Project       R.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC164CM-8F40
//
// @Compiler      Keil
//
// @Codegenerator 1.0
//
// @Description   This file contains all function prototypes and macros for 
//                the IO module.
//
//----------------------------------------------------------------------------
// @Date          27/1/2000 9:09:06 
//
//****************************************************************************

// USER CODE BEGIN (IO_Header,1)

// USER CODE END



#ifndef _IO_H_
#define _IO_H_

//****************************************************************************
// @Project Includes
//****************************************************************************

// USER CODE BEGIN (IO_Header,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (IO_Header,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

//----------------------------------------------------------------------------
// Defines for the parameter PinName
//----------------------------------------------------------------------------

//   
#define IO_P1H_0 P1H_P0

//   
#define IO_P1H_1 P1H_P1

//   
#define IO_P1H_2 P1H_P2

//   
#define IO_P1H_3 P1H_P3

//   
#define IO_P1H_4 P1H_P4

//   
#define IO_P1H_5 P1H_P5


//   
#define IO_P1L_0 P1L_P0

//   
#define IO_P1L_1 P1L_P1

//   
#define IO_P1L_2 P1L_P2

//   
#define IO_P1L_3 P1L_P3

//   
#define IO_P1L_4 P1L_P4

//   
#define IO_P1L_5 P1L_P5

//   
#define IO_P1L_6 P1L_P6

//   
#define IO_P1L_7 P1L_P7


//   
#define IO_P3_1 P3_P1

//   
#define IO_P3_2 P3_P2

//   
#define IO_P3_3 P3_P3

//   
#define IO_P3_4 P3_P4

//   
#define IO_P3_5 P3_P5

//   
#define IO_P3_6 P3_P6

//   
#define IO_P3_7 P3_P7

//   
#define IO_P3_8 P3_P8

//   
#define IO_P3_9 P3_P9

//   
#define IO_P3_10 P3_P10

//   
#define IO_P3_11 P3_P11

//   
#define IO_P3_13 P3_P13

//   
#define IO_P3_15 P3_P15


//   
#define IO_P5_0 P5_P0

//   
#define IO_P5_1 P5_P1

//   
#define IO_P5_2 P5_P2

//   
#define IO_P5_3 P5_P3

//   
#define IO_P5_4 P5_P4

//   
#define IO_P5_5 P5_P5

//   
#define IO_P5_6 P5_P6

//   
#define IO_P5_7 P5_P7

//   
#define IO_P5_10 P5_P10

//   
#define IO_P5_11 P5_P11

//   
#define IO_P5_12 P5_P12

//   
#define IO_P5_13 P5_P13

//   
#define IO_P5_14 P5_P14

//   
#define IO_P5_15 P5_P15


//   
#define IO_P9_0 P9_P0

//   
#define IO_P9_1 P9_P1

//   
#define IO_P9_2 P9_P2

//   
#define IO_P9_3 P9_P3

//   
#define IO_P9_4 P9_P4

//   
#define IO_P9_5 P9_P5



//----------------------------------------------------------------------------
// Defines used by DAvE
//----------------------------------------------------------------------------

#define INIO_P1H_0       P1H_P0
#define INIO_P1H_1       P1H_P1
#define INIO_P1H_2       P1H_P2
#define INIO_P1H_3       P1H_P3
#define INIO_P1H_4       P1H_P4
#define INIO_P1H_5       P1H_P5

#define DIO_P1H_0       DP1H_P0
#define DIO_P1H_1       DP1H_P1
#define DIO_P1H_2       DP1H_P2
#define DIO_P1H_3       DP1H_P3
#define DIO_P1H_4       DP1H_P4
#define DIO_P1H_5       DP1H_P5

#define INIO_P1L_0       P1L_P0
#define INIO_P1L_1       P1L_P1
#define INIO_P1L_2       P1L_P2
#define INIO_P1L_3       P1L_P3
#define INIO_P1L_4       P1L_P4
#define INIO_P1L_5       P1L_P5
#define INIO_P1L_6       P1L_P6
#define INIO_P1L_7       P1L_P7

#define DIO_P1L_0       DP1L_P0
#define DIO_P1L_1       DP1L_P1
#define DIO_P1L_2       DP1L_P2
#define DIO_P1L_3       DP1L_P3
#define DIO_P1L_4       DP1L_P4
#define DIO_P1L_5       DP1L_P5
#define DIO_P1L_6       DP1L_P6
#define DIO_P1L_7       DP1L_P7

#define INIO_P3_1       P3_P1
#define INIO_P3_2       P3_P2
#define INIO_P3_3       P3_P3
#define INIO_P3_4       P3_P4
#define INIO_P3_5       P3_P5
#define INIO_P3_6       P3_P6
#define INIO_P3_7       P3_P7
#define INIO_P3_8       P3_P8
#define INIO_P3_9       P3_P9
#define INIO_P3_10       P3_P10
#define INIO_P3_11       P3_P11
#define INIO_P3_13       P3_P13
#define INIO_P3_15       P3_P15

#define DIO_P3_1       DP3_P1
#define DIO_P3_2       DP3_P2
#define DIO_P3_3       DP3_P3
#define DIO_P3_4       DP3_P4
#define DIO_P3_5       DP3_P5
#define DIO_P3_6       DP3_P6
#define DIO_P3_7       DP3_P7
#define DIO_P3_8       DP3_P8
#define DIO_P3_9       DP3_P9
#define DIO_P3_10       DP3_P10
#define DIO_P3_11       DP3_P11
#define DIO_P3_13       DP3_P13
#define DIO_P3_15       DP3_P15

#define INIO_P5_0       P5_P0
#define INIO_P5_1       P5_P1
#define INIO_P5_2       P5_P2
#define INIO_P5_3       P5_P3
#define INIO_P5_4       P5_P4
#define INIO_P5_5       P5_P5
#define INIO_P5_6       P5_P6
#define INIO_P5_7       P5_P7
#define INIO_P5_10       P5_P10
#define INIO_P5_11       P5_P11
#define INIO_P5_12       P5_P12
#define INIO_P5_13       P5_P13
#define INIO_P5_14       P5_P14
#define INIO_P5_15       P5_P15


#define INIO_P9_0       P9_P0
#define INIO_P9_1       P9_P1
#define INIO_P9_2       P9_P2
#define INIO_P9_3       P9_P3
#define INIO_P9_4       P9_P4
#define INIO_P9_5       P9_P5

#define DIO_P9_0       DP9_P0
#define DIO_P9_1       DP9_P1
#define DIO_P9_2       DP9_P2
#define DIO_P9_3       DP9_P3
#define DIO_P9_4       DP9_P4
#define DIO_P9_5       DP9_P5

// USER CODE BEGIN (IO_Header,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (IO_Header,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (IO_Header,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (IO_Header,7)

// USER CODE END


//****************************************************************************
// @Prototypes Of Global Functions
//****************************************************************************

void IO_vInit(void);


// USER CODE BEGIN (IO_Header,8)

// USER CODE END


//****************************************************************************
// @Macro         IO_ubReadPin(PinName) 
//
//----------------------------------------------------------------------------
// @Description   This macro returns the status of the chosen portpin.
//                Note:
//                See the 'Defines for the parameter PinName' section in this 
//                header file for the available definitions for the parameter 
//                PinName.
//
//----------------------------------------------------------------------------
// @Returnvalue   Status of the chosen portpin
//
//----------------------------------------------------------------------------
// @Parameters    PinName: 
//                Pin to be read
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_ubReadPin(PinName) PinName


//****************************************************************************
// @Macro         IO_vSetPin(PinName) 
//
//----------------------------------------------------------------------------
// @Description   This macro sets the chosen portpin to '1'.
//                Note:
//                See the 'Defines for the parameter PinName' section in this 
//                header file for the available definitions for the parameter 
//                PinName.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PinName: 
//                Pin to be set to '1'
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vSetPin(PinName) PinName = 1


//****************************************************************************
// @Macro         IO_vResetPin(PinName) 
//
//----------------------------------------------------------------------------
// @Description   This macro sets the chosen portpin to '0'. 
//                Note: 
//                See the 'Defines for the parameter PinName' section in this 
//                header file for the available definitions for the parameter 
//                PinName.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PinName: 
//                Pin to be set to '0'
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vResetPin(PinName) PinName = 0


//****************************************************************************
// @Macro         IO_vTogglePin(PinName) 
//
//----------------------------------------------------------------------------
// @Description   This marco toggles the chosen portpin. 
//                Note:
//                See the 'Defines for the parameter PinName' section in this 
//                header file for the available definitions for the parameter 
//                PinName.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PinName: 
//                Pin to be toggled
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vTogglePin(PinName) PinName = !PinName


//****************************************************************************
// @Macro         IO_vSetPinIn(PinName) 
//
//----------------------------------------------------------------------------
// @Description   The chosen portpin is configured as input.
//                Note:
//                See the 'Defines for the parameter PinName' section in this 
//                header file for the available definitions for the parameter 
//                PinName.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PinName: 
//                Pin to be set to input
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vSetPinIn(PinName) D##PinName = 0


//****************************************************************************
// @Macro         IO_vSetPinOut(PinName) 
//
//----------------------------------------------------------------------------
// @Description   The chosen portpin is configured as output.
//                Note:
//                See the 'Defines for the parameter PinName' section in this 
//                header file for the available definitions for the parameter 
//                PinName.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PinName: 
//                Pin to be set to output
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vSetPinOut(PinName) D##PinName = 1


//****************************************************************************
// @Macro         IO_uwReadPort(PortName) 
//
//----------------------------------------------------------------------------
// @Description   This macro returns the value of the selected port. If a 
//                port has less than 16 pins, the unused bits are set to 0 in 
//                the return value
//                The following definitions for PortName are available:
//                P1H, P1L, P3, P5, P9, 
//
//----------------------------------------------------------------------------
// @Returnvalue   Value of the port
//
//----------------------------------------------------------------------------
// @Parameters    PortName: 
//                Port to be read
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_uwReadPort(PortName) PortName


//****************************************************************************
// @Macro         IO_vWritePort(PortName, uwData) 
//
//----------------------------------------------------------------------------
// @Description   The forwarded data is written to the selected port. If a 
//                port has less than 16 pins, the bits not used are ignored 
//                in the parameter value.
//                The following definitions for PortName are available:
//                P1H, P1L, P3, P5, P9, 
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PortName: 
//                Port to be altered
// @Parameters    uwData: 
//                Value to be written to the chosen port
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vWritePort(PortName, uwData) PortName = uwData


//****************************************************************************
// @Macro         IO_vSetPortIn(PortName, uwMask) 
//
//----------------------------------------------------------------------------
// @Description   This macro makes it possible to reconfigure the selected 
//                port. The parameter usMask determines which individual port 
//                pins are to be used as inputs. Every bit position in the 
//                parameter usMask corresponds to a port pin.
//                The following definitions for PortName are available:
//                P1H, P1L, P3, P5, P9, 
//                Example:
//                IO_vSetPortIn(P0,0x0204);  // sets P0.9 and P0.2 to input
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PortName: 
//                Port to be configured
// @Parameters    uwMask: 
//                Mask for port pins to be configured
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vSetPortIn(PortName, uwMask) D##PortName &= ~uwMask


//****************************************************************************
// @Macro         IO_vSetPortOut(PortName, uwMask) 
//
//----------------------------------------------------------------------------
// @Description   This macro makes it possible to reconfigure the selected 
//                port. The parameter usMask determines which individual port 
//                pins are to be used as outputs. Every bit position in the 
//                parameter usMask corresponds to a port pin.
//                The following definitions for PortName are available:
//                P1H, P1L, P3, P5, P9, 
//                Example:
//                IO_vSetPortOut(P0,0x0204);  // sets P0.9 and P0.2 to output
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    PortName: 
//                Port to be configured
// @Parameters    uwMask: 
//                Mask for port pins to be configured
//
//----------------------------------------------------------------------------
// @Date          27/1/2000
//
//****************************************************************************

#define IO_vSetPortOut(PortName, uwMask) D##PortName |= uwMask


//****************************************************************************
// @Interrupt Vectors
//****************************************************************************

// USER CODE BEGIN (IO_Header,9)

// USER CODE END


#endif  // ifndef _IO_H_
